package com.guerrero.retodeezer;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.deezer.sdk.model.Track;
import com.squareup.picasso.Picasso;

import java.util.ArrayList;

public class AdaptadorCancion extends BaseAdapter {



    public AdaptadorCancion(Activity activity) {
        this.activity = activity;
        lista_de_canciones = new ArrayList<>();
    }

    private Activity activity;
    private ArrayList<Track> lista_de_canciones;

    @Override
    public int getCount() {
        return lista_de_canciones.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }



    public void agregarCancion(Track track) {
        lista_de_canciones.add(track);
        notifyDataSetChanged();
    }

    public void borrarCancionesList() {
        if (lista_de_canciones.size() != 0 && lista_de_canciones != null) {
            lista_de_canciones.clear();
        }
        notifyDataSetChanged();
    }

    public ArrayList<Track> getLista_de_canciones() {
        return lista_de_canciones;
    }

    public void setLista_de_canciones(ArrayList<Track> lista_de_canciones) {
        this.lista_de_canciones = lista_de_canciones;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        LayoutInflater inflater = LayoutInflater.from(activity);
        View view = inflater.inflate(R.layout.renglon_cancion, null, false);
        TextView anio = view.findViewById(R.id.ano_lanzamiento);
        TextView ncancion = view.findViewById(R.id.nombre_cancion);
        ImageView img = view.findViewById(R.id.iv_image_other);
        TextView art = view.findViewById(R.id.artista_cancion);
        ncancion.setText("Nombre Canción: " + lista_de_canciones.get(position).getTitle());
        art.setText("Artista Canción: " + lista_de_canciones.get(position).getArtist().getName());
        anio.setText("Año de lanzamiento: " + lista_de_canciones.get(position).getReleaseDate());


        Picasso.get().load(lista_de_canciones.get(position).getAlbum().getSmallImageUrl()).into(img);
        return view;
    }


}