package com.guerrero.retodeezer;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.Toast;

import com.deezer.sdk.model.Playlist;
import com.deezer.sdk.network.connect.DeezerConnect;
import com.deezer.sdk.network.request.DeezerRequest;
import com.deezer.sdk.network.request.DeezerRequestFactory;
import com.deezer.sdk.network.request.event.JsonRequestListener;
import com.deezer.sdk.network.request.event.RequestListener;

import java.util.List;

public class MainActivity extends AppCompatActivity {

    private EditText buscador;
    private ImageButton buscar;
    private ListView lv_lista;
    private AdaptadorListaReproduccion adaptadorListaReproduccion;


    public final static String applicationID = "348224";


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        //enlaces con la vista
        buscador = findViewById(R.id.text_buscador);
        buscar = findViewById(R.id.btn_buscar);
        lv_lista = findViewById(R.id.lv_listas);

        Bundle bundle = getIntent().getExtras();
        String estadoAdaptador = "";
        if (bundle != null) {
            estadoAdaptador = bundle.getString("oldAdaptadorPlaylist");
        }
        adaptadorListaReproduccion = new AdaptadorListaReproduccion(this);

        lv_lista.setAdapter(adaptadorListaReproduccion);
        adaptadorListaReproduccion.notifyDataSetChanged();

        final DeezerConnect deezerConnect = new DeezerConnect(this, applicationID);
        final String temp = estadoAdaptador;
        if (!temp.equals("") && temp != null) {
         RequestListener listener = new JsonRequestListener() {

                    public void onResult(Object result, Object requestId) {
                        List<Playlist> listareprotemp = (List<Playlist>) result;
                        for (int i = 0; i < listareprotemp.size(); i++)
                            adaptadorListaReproduccion.agregarListaReproduc(listareprotemp.get(i));
                    }

                    public void onUnparsedResult(String requestResponse, Object requestId) {
                    }

                    public void onException(Exception e, Object requestId) {
                    }
                };
                DeezerRequest request = DeezerRequestFactory.requestSearchPlaylists(temp);
                request.setId("myRequest");
                deezerConnect.requestAsync(request, listener);
            }

            buscar.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    adaptadorListaReproduccion.borrarListadeListasRep();
                    RequestListener listener = new JsonRequestListener() {

                        public void onResult(Object result, Object requestId) {
                            List<Playlist> tempolistrepro = (List<Playlist>) result;
                            for (int i = 0; i < tempolistrepro.size(); i++)
                                adaptadorListaReproduccion.agregarListaReproduc(tempolistrepro.get(i));
                        }

                        public void onUnparsedResult(String requestResponse, Object requestId) {
                        }

                        public void onException(Exception e, Object requestId) {
                        }
                    };
                    if (buscador.getText().toString().isEmpty()){
                        Toast.makeText(MainActivity.this, "Debes escribir el nombre de una lista a buscar", Toast.LENGTH_SHORT).show();
                    }else{
                        DeezerRequest request = null;
                        if (!temp.equals(buscador.getText().toString())) {
                            request = DeezerRequestFactory.requestSearchPlaylists(buscador.getText().toString());
                        } else {
                            request = DeezerRequestFactory.requestSearchPlaylists(temp);
                        }

                        request.setId("myRequest");

                        // launch the request asynchronously
                        deezerConnect.requestAsync(request, listener);
                    }

                }
            });

            lv_lista.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                    long idPlaylist = Long.parseLong(adaptadorListaReproduccion.getLista_listas_de_reproduccion().get(position).getId() + "");
                    String valorabuscar = "";
                    if (temp!=null&&temp.equals("")) {
                        valorabuscar = buscador.getText().toString();
                    }else if (!temp.equals("")&&temp!=null&& buscador.getText().toString().equals("")){
                        valorabuscar = temp;
                    } else {
                        valorabuscar = buscador.getText().toString();
                    }
                    Intent i = new Intent(getApplicationContext(), PlaylistActivity.class);
                    i.putExtra("stringbusqueda", valorabuscar);
                    i.putExtra("idlistarepro", idPlaylist);
                    startActivity(i);
                    finish();
                }
            });

        }
}
