package com.guerrero.retodeezer;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.deezer.sdk.model.Playlist;
import com.deezer.sdk.network.connect.DeezerConnect;
import com.deezer.sdk.network.request.DeezerRequest;
import com.deezer.sdk.network.request.DeezerRequestFactory;
import com.deezer.sdk.network.request.event.JsonRequestListener;
import com.deezer.sdk.network.request.event.RequestListener;
import com.squareup.picasso.Picasso;

public class PlaylistActivity extends AppCompatActivity {


    private TextView descripcion;
    private TextView can_canciones;
    private ListView canciones;
    private AdaptadorCancion adaptadorCancion;
    private ImageView iv_flecha_to_main;
    private ImageView miniatura;
    private TextView nombre;
    private TextView fans;





    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_playlist);

        Bundle bundle = getIntent().getExtras();
        long idlistarepro = 0;
        String listabuscada = "";
        long idFromTrack = 0;

        idFromTrack = bundle.getLong("idFromTrack");
        idlistarepro = bundle.getLong("idlistarepro");
        listabuscada = bundle.getString("stringbusqueda");


        final long aux = idlistarepro;
        final String auxAdapPlaylist = listabuscada;
        final long auxIdPlayReceived = idFromTrack;

        iv_flecha_to_main = findViewById(R.id.btn_back);
        miniatura = findViewById(R.id.iv_playlist);
        nombre = findViewById(R.id.tv_nombre_playlist);
        descripcion = findViewById(R.id.tv_descripcion);
        can_canciones = findViewById(R.id.tv_numero_canciones);
        canciones = findViewById(R.id.lv_canciones);
        fans = findViewById(R.id.tv_numero_fans);
        adaptadorCancion = new AdaptadorCancion(this);

        canciones.setAdapter(adaptadorCancion);
        adaptadorCancion.notifyDataSetChanged();

        final DeezerConnect deezerConnect = new DeezerConnect(this, MainActivity.applicationID);

        // the request listener
        RequestListener jsonListener = new JsonRequestListener() {

            public void onResult(Object result, Object requestId) {
                adaptadorCancion.borrarCancionesList();
                Playlist playlist = (Playlist) result;
                Picasso.get().load(playlist.getPictureUrl()).into(miniatura);
                nombre.setText("Nombre: " + playlist.getTitle());
                descripcion.setText("Descripción: " + playlist.getDescription());
                can_canciones.setText("#Canciones: " + playlist.getTracks().size());
                fans.setText("#Fans: "+playlist.getFans());
                // do something with the albums
                for (int i = 0; i < playlist.getTracks().size(); i++)
                    adaptadorCancion.agregarCancion(playlist.getTracks().get(i));

            }

            public void onUnparsedResult(String requestResponse, Object requestId) {
            }

            public void onException(Exception e, Object requestId) {
            }
        };

        // create the request
        DeezerRequest request = null;
        if (auxIdPlayReceived==0){
            request = DeezerRequestFactory.requestPlaylist(idlistarepro);
        }else{
            request = DeezerRequestFactory.requestPlaylist(auxIdPlayReceived);
        }
        // set a requestId, that will be passed on the listener's callback methods
        request.setId("myRequest");
        // launch the request asynchronously
        deezerConnect.requestAsync(request, jsonListener);

        canciones.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Intent i = new Intent(getApplicationContext(), TrackActivity.class);
                long idTrack = Long.parseLong(adaptadorCancion.getLista_de_canciones().get(position).getId() + "");
                long idAdaptadorTrack = 0;
                if (auxIdPlayReceived==0) {
                    idAdaptadorTrack = aux;
                } else {
                    idAdaptadorTrack = auxIdPlayReceived;
                }
                i.putExtra("track", idTrack);
                i.putExtra("playlist",idAdaptadorTrack);
                i.putExtra("oldAdaptadorPlaylist",auxAdapPlaylist);
                startActivity(i);
                finish();
            }
        });

        iv_flecha_to_main.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent i = new Intent(getApplicationContext(), MainActivity.class);
                i.putExtra("oldAdaptadorPlaylist",auxAdapPlaylist);
                startActivity(i);
                finish();
            }
        });
    }
}
